/* Krister Swenson                                                  Spring 2006

Print "YES" if the given permutation has an island of size n where n is the
number of inversions from the identity.
*/

#include <iostream>
#include <vector>
#include <string>
#include "../graph/med.h"
#include "../seqtools/latticefuncs.h"


using namespace std; 
using namespace __gnu_cxx; 


int main()
  {
  int *targ=0;
  cout << "TARGET:\t";
  int targlen = getInputSeq(&targ);

  Ograph gr(targ, targlen);       //Build the graph.
  if(hasIsland(gr))
    cout << "YES" << endl;
  else
    cout << "NO" << endl;

  /* Don't forget that if you do this then you will have to unmark everything.

  string seqstr;
  seqstr = gr.getSeqString();
  hash_map<unsigned int, Vertex> vertexset;
  Vertex ub(DEKHash(seqstr));             //Make the upper bound,
  vertexset[ub.getLabel()] = ub;          //then add it to the vertex set
  fullLattice(vertexset, ub, gr, seqstr); //and build the lattice from it.
  cerr << "digraph G"
       << "\n  {\n  "
       << "size = \"10,7\";"
       << "orientation=landscape;"
       << "center=false;"
       << "concentrate=true;"
       << "ranksep=1.0;"
       << "bgcolor=transparent;"
       << endl;
  printLattice(vertexset[ub.getLabel()]);
  cerr << "  }\n";

  */

  free(targ);
  return(0);
  }





