/* Krister Swenson                                                 Summer 2006

Contains information about duplicates that are matched between the sequences.
*/


#include "DupInfo.h"

using namespace std;


DupInfo::DupInfo(const int name, const int index1, const int index2,
                 const int length)
  {
  gene = name;
  ind1 = index1;
  ind2 = index2;
  len = length;
  }

DupInfo::DupInfo()
  {
  ind1 = -1;
  ind2 = -1;
  gene = -1;
  len = -1;
  }

DupInfo::~DupInfo()
  {}

DupInfo::DupInfo(const DupInfo& d)
  { copy(d); }


/* Make them equal.
*/
void DupInfo::operator=(const DupInfo& d)
  { copy(d); }

/* Check for equality.
*/
bool DupInfo::operator==(const DupInfo& d) const
  { return ind1 == d.ind1 && ind2 == d.ind2 && gene == d.gene && len == d.len; }

/* Copy the object.
*/
void DupInfo::copy(const DupInfo& d)
  {
  ind1 = d.ind1;
  ind2 = d.ind2;
  gene = d.gene;
  len = d.len;
  }


ostream& operator<<(std::ostream& output, const DupInfo& d)
  {
  output << d.gene << "[" << d.ind1 << "," << d.ind2 << "]:" << d.len;
  return output;
  }
