/* Krister Swenson                                                 Summer 2006

Contains information about duplicates that are matched between the sequences.
*/

#ifndef DUPINFO_H
#define DUPINFO_H



#include <iostream>
#include <cstdio>


class DupInfo
  {
  friend std::ostream& operator<<(std::ostream& output, const DupInfo& d);

  public:
    DupInfo();
    DupInfo(const int name, const int index1, const int index2,
            const int length);
    DupInfo(const DupInfo& d);
    ~DupInfo();
    void operator=(const DupInfo& d);
    bool operator==(const DupInfo& d) const;


  private:
    void copy(const DupInfo& d);

    int ind1;   //The index from the first sequence.
    int ind2;   //The index from the second sequence.
    int gene;   //The actual duplicate this info is about.
    int len;    //The length of the cover element this was part of.
  };


#endif
