//This file is to evaluate the performance of the distance function for 
// phylogenetic data.
//Just run at the command line piping it the data from
// tree-gen.scm (or randtree.scm)
#define MAX_SEQ_LEN 4000
#define RAND_TRIES 1

#include <stdio.h>
#include <stdlib.h>
#include "multiMED.h"


int main()
{
  int i, j, c;
  int* temp;
  int* x;
  int* y;
  int* val;
  int* numSeqs;
  int* ts;
  int** seqs;
  int** distMatrix;
  int* s1;
  int* s2;
  int lenS1;
  int lenS2;

  numSeqs = (int*) malloc(sizeof(int));
  temp = (int*) malloc(sizeof(int));
  x = (int*) malloc(sizeof(int));
  y = (int*) malloc(sizeof(int));
  val = (int*) malloc(sizeof(int));
  scanf("%i", numSeqs);
  fprintf(stderr, "num seqs %i\n", *numSeqs);
  seqs = (int**) calloc(*numSeqs, sizeof(int*));

  //read in each of the sequences, first elem is the seq len rest are the values
  for(i = 0; i < *numSeqs; ++i)
    {
    ts = (int*) calloc(MAX_SEQ_LEN, sizeof(int));
     
    scanf(" ");
    j = 1;
    c = fgetc(stdin); //get rid of '('
    scanf(" "); //get rid of whitespace
    c = fgetc(stdin);
    while(c != 41)
    	{
        ungetc(c, stdin);
        fscanf(stdin, "%i", temp);
        ts[j] = *temp;
        scanf(" ");
        ++j;
        c = fgetc(stdin);
	}
    ts[0] = j - 1;
    seqs[i] = ts;
    
    //fprintf(stderr, "Length = %i\n", ts[0]);
    //fprintf(stderr, "[");
    //for(j = 0; j < ts[0]; ++j)
    //    fprintf(stderr, "%i ", ts[j]);
    //fprintf(stderr, "%i]\n\n", ts[ts[0]]);
    
    }

  //read in the distance matrix information
  scanf(" done ");
  //allocate the damn thing
  distMatrix = (int**) calloc(*numSeqs, sizeof(int*));
  for(i = 0; i < *numSeqs; ++i)
      distMatrix[i] = (int*) calloc(*numSeqs, sizeof(int));

  for(i = 0; i < (*numSeqs) * (*numSeqs); ++i)
    {
      scanf(" ");
      scanf("(%i . %i) %i", x, y, val);
      //fprintf(stderr, "%i %i %i\n", *x, *y, *val);
      distMatrix[*x][*y] = *val;
    }

  //do the dist computations and print the true length, the computed length
  // and the diff
  *x = 0;
  while(*x < *numSeqs)
    {
      *y = 0;
      while(*y < *x)
	{
        fprintf(stdout, "Seqs %i %i\n", *x, *y);
        fprintf(stdout, "rt %i\n", RAND_TRIES);
        for(j = 0; j < RAND_TRIES; ++j)
          {
            fprintf(stderr, "Seqs %i %i\n", *x, *y);
            lenS1 = seqs[*x][0];
            lenS2 = seqs[*y][0];
            s1 = (int*) calloc(lenS1, sizeof(int));
            s2 = (int*) calloc(lenS2, sizeof(int));
            for(i = 0; i < lenS1; ++i)
                s1[i] = seqs[*x][i + 1];
            for(i = 0; i < lenS2; ++i)
                s2[i] = seqs[*y][i + 1];


            //fprintf(stdout, "\n\nLength s1 = %i\n", lenS1);
            //fprintf(stdout, "[");
            //for(i = 0; i < lenS1 - 1; ++i)
            //    fprintf(stdout, "%i ", s1[i]);
            //fprintf(stdout, "%i]\n\n", s1[lenS1 - 1]);

            //fprintf(stdout, "Length s2 = %i\n", lenS2);
            //fprintf(stdout, "[");
            //for(i = 0; i < lenS2 - 1; ++i)
            //    fprintf(stdout, "%i ", s2[i]);
            //fprintf(stdout, "%i]\n\n", s2[lenS2 - 1]);
            
        
            *val = multiMED(s1, lenS1, s2, lenS2);
            fprintf(stdout, "Tree_val %i Computed_Val %i ", distMatrix[*x][*y], *val);
            fprintf(stdout, "Difference %i\n", distMatrix[*x][*y] - *val);
        
            free(s1);
            free(s2);
          }
        *y = *y + 1;
	}
      *x = *x + 1;
    }
    
  return 0;
}
