/* Krister Swenson                                                  Summer 2007

Get all the interfering inversion that share the given reality edge.
It does both desire edges connected to a reality edge seperately...
  the interferance between the groups for the two desire edges are not
calculated.
*/

#include "seqfuncs.h"
#include "../graph/Ograph.h"
#include <vector>


using namespace std; 


int main()
  {
  vector<Pair> oOps;

  int *s1=0;
  cerr << "sequence: ";
  int s1len = getInputSeq(&s1);

  int ri=0;                  //The reality edge index.
  cerr << "index: ";
  cin >> ri;

  Ograph g(s1, s1len);       //Build the graph.
  g.printSeqStr();           //Print it.
  cerr << endl;
  g.getCSInvs(oOps, ri);


  for(int j=0; size_t(j)<oOps.size(); j++)  //For each divergent op
    {
    cout << oOps[j] << ": ";
    g.revAll(oOps[j]);                      //do it
    int dist = g.getDistNH();
    for(int k=0; size_t(k)<oOps.size(); k++)//and check which still sort:
      {
      if(oOps[k] != oOps[j] &&              //Don't check the op against itself,
         !(oOps[j].getRight() < oOps[k].getLeft() || //and only check ops that
           oOps[k].getRight() < oOps[j].getLeft()))  //face the same direction.
        {
        Pair inv;                           //If the first op is shorter, then
        if(oOps[k].getRight() < oOps[j].getRight())
          {                                 //the endpoints will flip.
          int diff = oOps[k].getRight()-oOps[k].getLeft();
          inv = Pair(oOps[j].getRight()-diff , oOps[j].getRight());
          }                                 //The same for left-facing ops:
        else if(oOps[k].getLeft() > oOps[j].getLeft())
          {
          int diff = oOps[k].getRight()-oOps[k].getLeft();
          inv = Pair(oOps[j].getLeft(), oOps[j].getLeft()+diff);
          }
        else                                //Otherwise,
          inv = oOps[k];                    //they stay the same.


        g.revAll(inv);
        if(g.getDistNH() >= dist)
          cout << oOps[k] << " ";
        g.revAll(inv);
        }
      }
    g.revAll(oOps[j]);                      //Undo it.
    cout << endl;
    }

  free(s1);
  return(0);
  }
