/* Krister Swenson                                                  Fall 2008

Group the permutations of the given length (n) with n+1 breakpoints according
to the number of cycles when it reaches a positive permutation.
*/

#include <assert.h>
#include "../fast/Permutation.h"
#include "../graph/Ograph.h"
#include "seqfuncs.h"

//#BINTHEM

using namespace std; 


int main()
  {
  cout << "Length: ";
  int len;
  cin >> len;

  vector< vector< vector<int> > > distbins;
  distbins.resize(len+1);

  vector< vector<int> > bpperms = getBPPerm(len);
  for(vector< vector<int> >::iterator i=bpperms.begin(); i!=bpperms.end(); i++)
    {
    Permutation p(*i);
    ipair rev;
    while(p.nextRev(rev, USE_MIN));

#ifndef BINTHEM
    if(!p.isSorted())
      cout << *i << "\t--> " << p << endl;
    else
      cout << *i << endl;
#else
    Ograph g(p.getSeqVec());
    distbins[g.getDistNH()].push_back(*i);
#endif
    }


#ifdef BINTHEM
  for(unsigned i=0; i < distbins.size(); i++)
    {
    cout << "______________|" << i << ":" << endl;
    for(vector< vector<int> >::iterator j=distbins[i].begin();
        j!=distbins[i].end(); j++)
      cout << *j << endl;
    }
#endif

  return(0);
  }
