/* Krister Swenson                                                  Fall 2008

Test the sign flip heuristic.
*/

#include <assert.h>
#include "../fast/Permutation.h"
#include "../graph/Ograph.h"
#include "seqfuncs.h"

using namespace std; 

vector<int> flipOne(int elem, vector<int> p);

int main()
  {
  cout << "Length: ";
  int len;
  cin >> len;

  vector< vector<int> > bpperms = getBPPerm(len);
  for(vector< vector<int> >::iterator i=bpperms.begin(); i!=bpperms.end(); i++)
    {
    Permutation p(*i);
    ipair rev;
    while(p.nextRev(rev, USE_MIN));

    if(!p.isSorted())
      {
      int j = 1;             //Element to flip.
      bool found = false;
      while(j <= len)        //Try flipping elements:
        {
        Permutation q(flipOne(j++,*i));
        while(q.nextRev(rev, USE_MIN));
        if(q.isSorted())
          {
          found = true;
          break;
          }
        }
      if(!found)
        cout << *i << "\t--> " << p << endl;
      }
    }

  return(0);
  }


vector<int> flipOne(int elem, vector<int> p)
  {
  for(vector<int>::iterator i=p.begin(); i!=p.end(); i++)
    if(abs(*i) == elem)
      *i *= -1; 
  return p;
  }
