/* Krister Swenson                                                  Spring 2006

Print the size of the largest signature between all the given sequences
(with the identity as the implicit locus).
Each sequence should be given on it's own line.
*/

#include <vector>
#include "../graph/Ograph.h"
#include "sigfuncs.h"
#include "../seqtools/seqfuncs.h"

using namespace std; 



int main()
  {
  vector<Ograph> graphs;
  int *tmp=0;

  while(int len = getInputSeq(&tmp))         //For each input sequence
    {
    graphs.push_back(Ograph(tmp, len, true));//add the inverse graph and
    assert(graphs[0].getSeqLen() == len);    //make sure it the proper length.
    free(tmp);
    }

  if(graphs.size() < 2)
    return 0;

  cerr << "SP:";
  int maxdepth = getGreedySigSP(graphs);
  cout << maxdepth << endl;


  return(0);
  }
