/* Krister Swenson                                                  Spring 2006

Print all maximum signature between the two given sequences
(with the identity as the implicit third).
*/

#include "sigfuncs.h"
#include "../seqtools/seqfuncs.h"
#include <vector>

using namespace std; 



int main()
  {
  int *s1=0, *s2=0;
  int s1len = getInputSeq(&s1);
  int s2len = getInputSeq(&s2);

  assert(s1len == s2len);

  Ograph g1(s1, s1len);      //Build the graph for s1.
  Ograph g2(s2, s2len);      //Build the graph for s2.

  Ograph id(makeID(s2len), s2len); //Build the identity graph.

  vector<Ograph> sigs;
  sigs = getSigs(g1, g2, id);

  cout << "size:" << sigs[0].getDistNH() << endl;
  int count=0;
  for(vector<Ograph>::iterator i = sigs.begin(); i != sigs.end(); i++)
    {
    count++;
    cout << "seq" << count << ": " << i->getSeqString() << endl;
    }

  free(s1);
  free(s2);
  return(0);
  }
