/* dfmax.c
 * Semi-Exhaustive Greedy Independent Set
 * from Matula and Johri
 *
 * written October 22, 1983 by DSJ
 * modified February 20, 1987 for checkpointing
 * modified August 1988 to find maximum independent sets
 * modified April 1993 for new data structures, bounding
 * modified September 1993 for dimacs .b input
 * modified February 2008 to compile with g++ by krister
 */
#ifndef DFMAX_H
#define DFMAX_H

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <string.h>
#include <sys/types.h>
#include <sys/times.h>
#include <time.h>
#include <assert.h>
#include <list>
#include <vector>
#define INT 32		/* computer word size */
//#define CHARBITS 8
#define edge(x,y) (bitmap[y][x])

#define NMAX 2400		       /* maximum number of vertices handles */
#define MAX_NR_VERTICES		2400   /* = NMAX */
#define MAX_NR_VERTICESdiv8	300    /* = NMAX/8 */
#define BOOL	char
#define MAX_PREAMBLE 10000
#define REORDER

using namespace std;

void check();	/* checks to see that chosen color class is ind. set */
void readgraph(FILE *fp);         /* reads input graph in bitmapform */

   //Find a maximum size clique.
   //-matrix- is the adjacency matrix while -labels- and -degrees- hold the
   // respective information for the rows of the matrix.  -goal- is the minimum
   // size clique to start looking for.
list<int> maxclique(const vector< vector<int> > &adjmatrix,
                    const vector<int> &labels, const vector<int> &degrees,
                    int goal = 1);
int maxindREORDER(int goal = 1);  //Find a clique of size at lease -goal-.
int maxind(int top,int goal,int *array,int depth);
int get_params();
BOOL get_edge(int i, int j);


#endif
