/* Krister Swenson                                                 Winter 2007-8

A random assortement of functions.
*/

#include "tools.h"

using namespace std;


/* Take a list and return a set with the same elements.
*/
set<int> listTOset(const list<int> &l)
  {
  set<int> ret;

  for(list<int>::const_iterator i = l.begin(); i != l.end(); i++)
    ret.insert(*i);

  return ret;
  }

/*Return the mean of the given vector.
*/
float getMean(const vector<int> &v)
  { return (float)accumulate(v.begin(), v.end(), 0)/v.size(); }
float getMean(const vector<float> &v)
  { return (float)accumulate(v.begin(), v.end(), 0.0)/(float)v.size(); }

/*Return the standard deviation of the values in the given vector.
*/
float getStandardDev(const vector<int> &v)
  {
  float mean = getMean(v);
  int totaldifference = 0;
  for(unsigned i=0; i < v.size(); i++)
    totaldifference += (mean-v[i])*(mean-v[i]);
  float variance = (float)totaldifference/v.size();

  return sqrtf(variance);
  }
/*Return the standard deviation of the values in the given vector.
*/
float getStandardDev(const vector<float> &v)
  {
  float mean = getMean(v);
  float totaldifference = 0;
  for(unsigned i=0; i < v.size(); i++)
    totaldifference += (mean-v[i])*(mean-v[i]);
  float variance = (float)totaldifference/v.size();

  return sqrtf(variance);
  }

/*Return n!
*/
long long factorial(int n)
  {
  long long retval=1;
  while(n)
    retval *= n--;
  return retval;
  }

/* Computes n choose k.  From wikipedia.
*/
unsigned long long choose(int n, int k)
  {
  if(n <= 0 || k < 0 || k > n)
    return 0;

  if(k > n/2)
    k = n-k; // faster

  long long n_minus_k = n-k;
  long double accum = 1;

  for(int i = 0; i++ < k;)
    accum = accum * (n_minus_k+i) / i;

  return (unsigned long long)(accum + 0.5); // avoid rounding error
  }


/* Return a string for the given set.
 * ({2.3.4} becomes {2.-.3})
*/
string getInvSetStr(const set<int> &theset)
  {
  if(theset.empty())
    return "";

  std::stringstream output;    //The string to return.

  std::set<int>::const_iterator elem = theset.begin();
  output << "{" << *elem;
  int last = *elem++;
  while(elem != theset.end())
    {
    if(*elem == last+1)
      {
      std::set<int>::const_iterator tmp = elem; tmp++;
      if((tmp != theset.end()) && (*tmp == *elem + 1))
        {
        while((tmp != theset.end()) && (*tmp == *elem+1))
          {
          elem = tmp;
          tmp++;
          }
        output << ".-";
        }
      }
    output << "." << *elem;
    last = *elem++;
    }
  output << "}";

  return output.str();
  }

